#include "stc15f104e.h" 
#include "intrins.h"//ͷļ//

sbit blue=P3^0;
sbit yellow=P3^1;
sbit red=P3^3;
sbit temp=P3^4;
sbit out=P3^5;
//š//

void bluetemp();
void yellowtemp();
void redtemp();
void Timer0Init(void);
unsigned char	Ds18b20Init();

unsigned char xx;//ȫֱ
unsigned int ss;//嶨ʱ
unsigned char m;//¶ȼ߱

void Delay1ms(unsigned int y) //ʱ
{
	unsigned char i, j;
	while(y--)
		{
	    _nop_();
	    _nop_();
	    i = 12;
	    j = 168;
	    do
    	{
				while (--j);
			}
		    while (--i);
		}
}

void Delay1us()		//@12.000MHz
{
	_nop_();
	_nop_();
}

unsigned char Ds18b20Init()//ds18b20ʼ
{
	int p;
	temp=0;
	for(p=0;p<300;p++)
	Delay1us(); //ʱ590us.
	temp=1;
	p=0;
	while(temp)
	{
		Delay1us();
		p++;
		if(p>5000)
		{
			return 0;//ʼʧܡ
		}
	}
	return 1; //ʼɹ
}

void Ds18b20WriteByte(unsigned char dat)
{
	unsigned char i,j;
	for(i=0;i<8;i++)
	{
		temp=0;
		Delay1us();
		temp=dat & 0x01;
		for(j=0;j<68;j++)
		Delay1us();
		temp=1;
		Delay1us();
		Delay1us();
		dat >>= 1;
	}
}

unsigned char Ds18b20ReadByte()
{
	unsigned char byte,bi;
	unsigned char i,j;
	for(j=0;j<8;j++)
	{
		temp=0;
		Delay1us();
		temp=1;
		for(i=0;i<6;i++)
		Delay1us();//ʱ6us
		bi=temp;
		byte = (byte >> 1) | (bi << 7);	
		for(i=0;i<48;i++)
		Delay1us();//ʱ48us
	}
	return byte;
}

void  Ds18b20ChangTemp()//ת¶
{
	Ds18b20Init();
	Delay1ms(1);
	Ds18b20WriteByte(0xcc);		//ROM	 
	Ds18b20WriteByte(0x44);	  //¶ת
}

void  Ds18b20ReadTempCom()//Ͷȡ¶
{	

	Ds18b20Init();
	Delay1ms(1);
	Ds18b20WriteByte(0xcc);	 //ROM
	Ds18b20WriteByte(0xbe);	 //Ͷȡ¶
}

int Ds18b20ReadTemp()
{
	int temp00 = 0;
	unsigned char tmh, tml;
	Ds18b20ChangTemp();			 	//дת
	Ds18b20ReadTempCom();			//ȻȴתͶȡ¶
	tml = Ds18b20ReadByte();		//ȡ¶ֵ16λȶֽڡ
	tmh = Ds18b20ReadByte();		//ٶֽڡ
	temp00 = tmh;
	temp00 <<= 8;
	temp00 |= tml;
	return temp00;
}

int datapros(int temp11) 	 
{
   float tp;  
	if(temp11< 0)				//¶ֵΪ
  	{
		//Ϊȡ¶ʵ¶ȵĲ룬Լ1ȡԭ롣
		temp11=temp11-1;
		temp11=~temp11;
		tp=temp11;
		temp11=tp*0.0625*100+0.5;	
		//С*100+0.5룬ΪCԸתΪ͵ʱС
		//ԶȥǷ0.5+0.5֮0.5ľǽ1ˣС0.5ľ
		//0.5С
		return temp11;
  	}
 	else
  	{			
		tp=temp11;//ΪݴСԽ¶ȸһͱ
		//¶ôôԭǲ
		temp11=tp*0.0625*100+0.5;	
		//С*100+0.5룬ΪCԸתΪ͵ʱС
		//ԶȥǷ0.5+0.5֮0.5ľǽ1ˣС0.5ľ
		//0.5С
    return temp11;
	}
		
}

void check()
{
  if(Ds18b20Init())
	{ET0=1;Delay1ms(1);Timer0Init();m=1;}
	else
	{ET0=0;m=0;}//¶ȼͷߣر¶ȼ⹦ܣ޷red
}

void main()
{
	EA=1; //жϡ
	EX0=1;  //ⲿж0
	IT0=1;  //½ش
	out=0;  //outõ͡
	blue=1;
	yellow=1;
	red=1;   //ָʾϨ
	xx=0;  //xx0
	ss=0;//ss0
	Delay1ms(1);
	check();
	while(1)
	{
	  switch(xx)
  	{
		  case 1:
				blue=0;yellow=1;red=1;bluetemp();break;
			case 2:
				blue=1;yellow=0;red=1;yellowtemp();break;
			case 3:
				blue=1;yellow=1;red=0;redtemp();break;
			default:
				blue=1;yellow=1;red=1;out=0;
			_nop_();
	    _nop_();
	    _nop_();
  	  _nop_();
	    _nop_();
	    PCON=0x02;
	    _nop_();
  	  _nop_();
	    _nop_();
    	_nop_();
	    _nop_();
			break;
	  }
	}
}

void sss() interrupt 0
{
	xx++;
	switch(m)
	{
		case 0:
			if(xx>2){xx=0;} break;
		case 1:
			if(xx>3){xx=0;} break;
		default:
			xx=0;break;
	}
}

void Delay960us()		//@12.000MHz
{
	unsigned char i, j;

	_nop_();
	_nop_();
	i = 12;
	j = 48;
	do
	{
		while (--j);
	} while (--i);
}

void Delay1040us()		//@12.000MHz
{
	unsigned char i, j;

	_nop_();
	_nop_();
	i = 13;
	j = 31;
	do
	{
		while (--j);
	} while (--i);
}

void bluetemp()//ʴԼ4ߡ
{
	while(1)
	{
		out=1;
		Delay960us();
		out=0;
		Delay1040us();
		if(xx!=1)
		{out=0;break;}
	}
}

void Delay1440us()		//@12.000MHz
{
	unsigned char i, j;

	_nop_();
	_nop_();
	i = 17;
	j = 203;
	do
	{
		while (--j);
	} while (--i);
}

void Delay560us()		//@12.000MHz
{
	unsigned char i, j;

	_nop_();
	_nop_();
	i = 7;
	j = 133;
	do
	{
		while (--j);
	} while (--i);
}

void yellowtemp()//ʴԼ6ߡ
{
	while(1)
	{
		out=1;
		Delay1440us();
		out=0;
		Delay560us();
		if(xx!=2)
		{out=0;break;}
	}
}

void redtemp()//ȫԼ8ߡ
{
	while(1)
	{
		out=1;
		if(xx!=3)
		{out=0;break;}
	}
}

void Timer0Init(void)		
{
	AUXR |= 0x80;	
	TMOD &= 0xF0;		
	TL0 = 0xA0;		
	TH0 = 0x15;	
	TF0 = 0;	
	TR0 = 1;		
}

void xsx() interrupt 1 //¶ȼ⣬ڵ75жϵԴ澯
{
	int a=0;
	ss++;
	a=Ds18b20Init();
	switch(a)
	{
		case 1:
			if(ss>400)
			{
				ss=0;
				a=datapros(Ds18b20ReadTemp());
				if(a>=7500)
				{
					xx=0;out=0;blue=0;yellow=0;red=0;
					_nop_();
					_nop_();
					_nop_();
					_nop_();
					_nop_();
					PCON=0x02;
					_nop_();
					_nop_();
					_nop_();
					_nop_();
					_nop_();
				}
			}break;
		case 0:
			ET0=0;m=0;xx=0;out=0;blue=0;yellow=0;red=0;break;
		default:
			ET0=0;m=0;xx=0;out=0;blue=0;yellow=0;red=0;break;
	}
}
/**************************/
/**************************/
/**programmed by Aunt Liu**/
/**************************/
/**************************/